# coding: utf-8

"""
    Geo Engine API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.8.0
    Contact: dev@geoengine.de
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from geoengine_openapi_client.models.ml_tensor_shape3_d import MlTensorShape3D
from geoengine_openapi_client.models.raster_data_type import RasterDataType
from typing import Optional, Set
from typing_extensions import Self

class MlModelMetadata(BaseModel):
    """
    MlModelMetadata
    """ # noqa: E501
    file_name: StrictStr = Field(alias="fileName")
    input_shape: MlTensorShape3D = Field(alias="inputShape")
    input_type: RasterDataType = Field(alias="inputType")
    output_shape: MlTensorShape3D = Field(alias="outputShape")
    output_type: RasterDataType = Field(alias="outputType")
    __properties: ClassVar[List[str]] = ["fileName", "inputShape", "inputType", "outputShape", "outputType"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MlModelMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of input_shape
        if self.input_shape:
            _dict['inputShape'] = self.input_shape.to_dict()
        # override the default output from pydantic by calling `to_dict()` of output_shape
        if self.output_shape:
            _dict['outputShape'] = self.output_shape.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MlModelMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fileName": obj.get("fileName"),
            "inputShape": MlTensorShape3D.from_dict(obj["inputShape"]) if obj.get("inputShape") is not None else None,
            "inputType": obj.get("inputType"),
            "outputShape": MlTensorShape3D.from_dict(obj["outputShape"]) if obj.get("outputShape") is not None else None,
            "outputType": obj.get("outputType")
        })
        return _obj


