# coding: utf-8

"""
    Geo Engine API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.8.0
    Contact: dev@geoengine.de
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List
from geoengine_openapi_client.models.ogr_source_time_format import OgrSourceTimeFormat
from typing import Optional, Set
from typing_extensions import Self

class OgrSourceDatasetTimeTypeStartEnd(BaseModel):
    """
    OgrSourceDatasetTimeTypeStartEnd
    """ # noqa: E501
    end_field: StrictStr = Field(alias="endField")
    end_format: OgrSourceTimeFormat = Field(alias="endFormat")
    start_field: StrictStr = Field(alias="startField")
    start_format: OgrSourceTimeFormat = Field(alias="startFormat")
    type: StrictStr
    __properties: ClassVar[List[str]] = ["endField", "endFormat", "startField", "startFormat", "type"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['start+end']):
            raise ValueError("must be one of enum values ('start+end')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OgrSourceDatasetTimeTypeStartEnd from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of end_format
        if self.end_format:
            _dict['endFormat'] = self.end_format.to_dict()
        # override the default output from pydantic by calling `to_dict()` of start_format
        if self.start_format:
            _dict['startFormat'] = self.start_format.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OgrSourceDatasetTimeTypeStartEnd from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "endField": obj.get("endField"),
            "endFormat": OgrSourceTimeFormat.from_dict(obj["endFormat"]) if obj.get("endFormat") is not None else None,
            "startField": obj.get("startField"),
            "startFormat": OgrSourceTimeFormat.from_dict(obj["startFormat"]) if obj.get("startFormat") is not None else None,
            "type": obj.get("type")
        })
        return _obj


